<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Rectangles</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-primitive-apis.html" title="Geometry">
<link rel="prev" href="cogl-2.0-experimental-Path-Primitives.html" title="Path Primitives">
<link rel="next" href="cogl-textures.html" title="Textures">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-2.0-experimental-Path-Primitives.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-primitive-apis.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-textures.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-Rectangles.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-Rectangles.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-Rectangles"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-Rectangles.top_of_page"></a>Rectangles</span></h2>
<p>Rectangles</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-Rectangles.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis"><span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle" title="cogl_rectangle ()">cogl_rectangle</a>                      (<em class="parameter"><code><span class="type">float</span> x_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x_2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y_2</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangles" title="cogl_rectangles ()">cogl_rectangles</a>                     (<em class="parameter"><code>const <span class="type">float</span> *verts</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> n_rects</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle-with-texture-coords" title="cogl_rectangle_with_texture_coords ()">cogl_rectangle_with_texture_coords</a>  (<em class="parameter"><code><span class="type">float</span> x1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty2</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangles-with-texture-coords" title="cogl_rectangles_with_texture_coords ()">cogl_rectangles_with_texture_coords</a> (<em class="parameter"><code>const <span class="type">float</span> *verts</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> n_rects</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle-with-multitexture-coords" title="cogl_rectangle_with_multitexture_coords ()">cogl_rectangle_with_multitexture_coords</a>
                                                        (<em class="parameter"><code><span class="type">float</span> x1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y2</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *tex_coords</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> tex_coords_len</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Rectangles.description"></a><h2>Description</h2>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Rectangles.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="cogl-rectangle"></a><h3>cogl_rectangle ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_rectangle                      (<em class="parameter"><code><span class="type">float</span> x_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x_2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y_2</code></em>);</pre>
<p>
Fills a rectangle at the given coordinates with the current source material
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>x_1</code></em> :</span></p></td>
<td>X coordinate of the top-left corner</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y_1</code></em> :</span></p></td>
<td>Y coordinate of the top-left corner</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x_2</code></em> :</span></p></td>
<td>X coordinate of the bottom-right corner</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y_2</code></em> :</span></p></td>
<td>Y coordinate of the bottom-right corner</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-rectangles"></a><h3>cogl_rectangles ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_rectangles                     (<em class="parameter"><code>const <span class="type">float</span> *verts</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> n_rects</code></em>);</pre>
<p>
Draws a series of rectangles in the same way that
<a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle" title="cogl_rectangle ()"><code class="function">cogl_rectangle()</code></a> does. In some situations it can give a
significant performance boost to use this function rather than
calling <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle" title="cogl_rectangle ()"><code class="function">cogl_rectangle()</code></a> separately for each rectangle.
</p>
<p>
<em class="parameter"><code>verts</code></em> should point to an array of <span class="type">float</span>s with
<em class="parameter"><code>n_rects</code></em> * 4 elements. Each group of 4 values corresponds to the
parameters x1, y1, x2, and y2, and have the same
meaning as in <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle" title="cogl_rectangle ()"><code class="function">cogl_rectangle()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>verts</code></em> :</span></p></td>
<td>an array of vertices. <span class="annotation">[<acronym title="Parameter for input. Default is transfer none."><span class="acronym">in</span></acronym>][<acronym title="Parameter points to an array of items."><span class="acronym">array</span></acronym>][<acronym title="Don't free data after the code is done."><span class="acronym">transfer none</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>n_rects</code></em> :</span></p></td>
<td>number of rectangles to draw</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-rectangle-with-texture-coords"></a><h3>cogl_rectangle_with_texture_coords ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_rectangle_with_texture_coords  (<em class="parameter"><code><span class="type">float</span> x1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty2</code></em>);</pre>
<p>
Draw a rectangle using the current material and supply texture coordinates
to be used for the first texture layer of the material. To draw the entire
texture pass in <em class="parameter"><code>tx1</code></em>=0.0 <em class="parameter"><code>ty1</code></em>=0.0 <em class="parameter"><code>tx2</code></em>=1.0 <em class="parameter"><code>ty2</code></em>=1.0.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>x1</code></em> :</span></p></td>
<td>x coordinate upper left on screen.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y1</code></em> :</span></p></td>
<td>y coordinate upper left on screen.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x2</code></em> :</span></p></td>
<td>x coordinate lower right on screen.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y2</code></em> :</span></p></td>
<td>y coordinate lower right on screen.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>tx1</code></em> :</span></p></td>
<td>x part of texture coordinate to use for upper left pixel</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>ty1</code></em> :</span></p></td>
<td>y part of texture coordinate to use for upper left pixel</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>tx2</code></em> :</span></p></td>
<td>x part of texture coordinate to use for lower right pixel</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>ty2</code></em> :</span></p></td>
<td>y part of texture coordinate to use for left pixel</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-rectangles-with-texture-coords"></a><h3>cogl_rectangles_with_texture_coords ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_rectangles_with_texture_coords (<em class="parameter"><code>const <span class="type">float</span> *verts</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> n_rects</code></em>);</pre>
<p>
Draws a series of rectangles in the same way that
<a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle-with-texture-coords" title="cogl_rectangle_with_texture_coords ()"><code class="function">cogl_rectangle_with_texture_coords()</code></a> does. In some situations it can give a
significant performance boost to use this function rather than
calling <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle-with-texture-coords" title="cogl_rectangle_with_texture_coords ()"><code class="function">cogl_rectangle_with_texture_coords()</code></a> separately for each rectangle.
</p>
<p>
<em class="parameter"><code>verts</code></em> should point to an array of <span class="type">float</span>s with
<em class="parameter"><code>n_rects</code></em> * 8 elements. Each group of 8 values corresponds to the
parameters x1, y1, x2, y2, tx1, ty1, tx2 and ty2 and have the same
meaning as in <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle-with-texture-coords" title="cogl_rectangle_with_texture_coords ()"><code class="function">cogl_rectangle_with_texture_coords()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>verts</code></em> :</span></p></td>
<td>an array of vertices. <span class="annotation">[<acronym title="Parameter for input. Default is transfer none."><span class="acronym">in</span></acronym>][<acronym title="Parameter points to an array of items."><span class="acronym">array</span></acronym>][<acronym title="Don't free data after the code is done."><span class="acronym">transfer none</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>n_rects</code></em> :</span></p></td>
<td>number of rectangles to draw</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 0.8.6</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-rectangle-with-multitexture-coords"></a><h3>cogl_rectangle_with_multitexture_coords ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_rectangle_with_multitexture_coords
                                                        (<em class="parameter"><code><span class="type">float</span> x1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y2</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *tex_coords</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> tex_coords_len</code></em>);</pre>
<p>
This function draws a rectangle using the current source material to
texture or fill with. As a material may contain multiple texture layers
this interface lets you supply texture coordinates for each layer of the
material.
</p>
<p>
The first pair of coordinates are for the first layer (with the smallest
layer index) and if you supply less texture coordinates than there are
layers in the current source material then default texture coordinates
(0.0, 0.0, 1.0, 1.0) are generated.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>x1</code></em> :</span></p></td>
<td>x coordinate upper left on screen.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y1</code></em> :</span></p></td>
<td>y coordinate upper left on screen.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x2</code></em> :</span></p></td>
<td>x coordinate lower right on screen.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y2</code></em> :</span></p></td>
<td>y coordinate lower right on screen.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>tex_coords</code></em> :</span></p></td>
<td>An array containing groups of
4 float values: [tx1, ty1, tx2, ty2] that are interpreted as two texture
coordinates; one for the upper left texel, and one for the lower right
texel. Each value should be between 0.0 and 1.0, where the coordinate
(0.0, 0.0) represents the top left of the texture, and (1.0, 1.0) the
bottom right. <span class="annotation">[<acronym title="Parameter for input. Default is transfer none."><span class="acronym">in</span></acronym>][<acronym title="Parameter points to an array of items."><span class="acronym">array</span></acronym>][<acronym title="Don't free data after the code is done."><span class="acronym">transfer none</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>tex_coords_len</code></em> :</span></p></td>
<td>The length of the tex_coords array. (e.g. for one layer
and one group of texture coordinates, this would be 4)</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.0</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>